﻿//using Common;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using Syncfusion.UI.Xaml.Utils;

namespace GridData
{
    internal delegate void Toggled();
    public class OrderInfoViewModel :INotifyPropertyChanged, IDisposable
    {
        public Popup CustomChooser { get; set; }
        public OrderInfoViewModel()
        {            
            OrdersListDetails = new OrderInfoRepository().GetListOrdersDetails(2000);
            this.CustomChooser = new Popup();
        }

        internal Toggled toggled;

        private ICommand togglebuttonToggled;

        public ICommand TogglebuttonToggled
        {
            get { return new DelegateCommand(ToggledEvent, args => true); }
            set { togglebuttonToggled = value; RaisePropertyChanged("TogglebuttonToggled"); }
        }

        private void ToggledEvent(object pram)
        {
            if (pram != null)
            {
                this.ShowColumnChooser = (bool)pram;
                toggled();
            }
        }

        private bool showColumnChooser = true;

        public bool ShowColumnChooser
        {
            get
            {
                return showColumnChooser;
            }
            set
            {
                showColumnChooser = value;
                RaisePropertyChanged("ShowColumnChooser");
            }
        }

        private bool useDefaultColumnChooser = true;

        public bool UseDefaultColumnChooser
        {
            get
            {
                return useDefaultColumnChooser;
            }
            set
            {
                useDefaultColumnChooser = value;
                RaisePropertyChanged("UseDefaultColumnChooser");
            }
        }

        private bool useCustomColumnChooser;

        public bool UseCustomColumnChooser
        {
            get
            {
                return useCustomColumnChooser;
            }
            set
            {
                useCustomColumnChooser = value;
                RaisePropertyChanged("UseCustomColumnChooser");
            }
        }

        #region Delegate Command

        public DelegateCommand<object> _ColumnChooserCommand;

        /// <summary>
        /// Gets the column chooser command.
        /// </summary>
        /// <value>The column chooser command.</value>
        public DelegateCommand<object> ColumnChooserCommand
        {
            get { return _ColumnChooserCommand; }
            set
            {
                _ColumnChooserCommand = value;
                RaisePropertyChanged("ColumnChooserCommand");
            }
        }
        #endregion

        private List<OrderInfo> _ordersListDetails;

        /// <summary>
        /// Gets or sets the orders details.
        /// </summary>
        /// <value>The orders details.</value>
        public List<OrderInfo> OrdersListDetails
        {
            get { return _ordersListDetails; }
            set { _ordersListDetails = value; }
        }

        private ObservableCollection<OrderInfo> _ordersDetails;

        /// <summary>
        /// Gets or sets the orders details.
        /// </summary>
        /// <value>The orders details.</value>
        public ObservableCollection<OrderInfo> OrdersDetails
        {
            get { return _ordersDetails; }
            set { _ordersDetails = value; }
        }

        public void Dispose()
        {
            if (OrdersDetails != null)
            {
                this.OrdersDetails.Clear();
            }
            if (this.OrdersListDetails != null)
            {
                this.OrdersListDetails.Clear();
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void RaisePropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChangedEventHandler handler = PropertyChanged;
            if (handler != null) handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
